#include "Record.h"
#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

Record::Record(const char *n, const char *c, const char *m){
    nome = new char[strlen(n) + 1];
    cognome = new char[strlen(c) + 1];
    matricola = new char[strlen(m) + 1];
    strcpy(matricola, m);
    strcpy(nome, n);
    strcpy(cognome, c);
}

Record::Record(const Record &r){
    nome = new char[strlen(r.nome) + 1];
    cognome = new char[strlen(r.cognome) + 1];
    matricola = new char[strlen(r.matricola) + 1];
    strcpy(matricola, r.matricola);
    strcpy(nome, r.nome);
    strcpy(cognome, r.cognome);
    v.resize(r.v.size());
    for(unsigned int i = 0; i < v.size(); i++){
        v[i] = r.v[i];
    }
}

Record Record::operator=(Record r){
    delete nome; delete cognome; delete matricola;
    nome = new char[strlen(r.nome) + 1];
    cognome = new char[strlen(r.cognome) + 1];
    matricola = new char[strlen(r.matricola) + 1];
    strcpy(matricola, r.matricola);
    strcpy(nome, r.nome);
    strcpy(cognome, r.cognome);
    v.resize(r.v.size());
    for(unsigned int i = 0; i < r.v.size(); i++){
        v[i] = r.v[i];
    }    
    return *this;
}


Record::~Record(){
    delete nome; 
    delete cognome;
    delete matricola;
    v.clear();
}


Record::Record(){
    nome = new char('\0');
    cognome = new char('\0');
    matricola = new char('\0');
}


void Record::setNome(const char *n){
    delete nome;
    nome = new char[strlen(n) + 1];
    strcpy(nome, n);
}

void Record::setCognome(const char *c){
    delete cognome;
    cognome = new char[strlen(c) + 1];
    strcpy(cognome, c);
}

istream &operator >> (istream &i, Record &r){
    char app[100];
    i >> app;
    delete r.nome;
    r.nome = new char(strlen(app) + 1);
    strcpy(r.nome, app);
    i >> app;
    delete r.cognome;
    r.cognome = new char(strlen(app) + 1);
    strcpy(r.cognome, app);
    i >> app;
    delete r.matricola;
    r.matricola = new char(strlen(app) + 1);
    strcpy(r.matricola , app);
    int numEsami;
    i >> numEsami;
    r.v.resize(numEsami);
    for(int count = 0; count < numEsami; count++){
        i >> r.v[count];
    }
    
    return i;
}

ostream &operator << (ostream &o, Record &r){
    o << r.nome << " " << r.cognome << " " << r.matricola << " ";
    for(unsigned int i = 0; i < r.v.size(); i++){
        o << r.v[i] << " ";
    }
    return o;
}

istream &operator >> (istream &i, vector<Record> &v){
    Record app;
    while(!i.eof()){
        i >> app;
        if (!i.eof())
            v.push_back(app);
    }
    return i;

}
ostream &operator << (ostream &o, vector<Record> &v){
    for(unsigned int i = 0; i < v.size(); i++){
        o << v[i] << endl;
    }
    return o;
}

float Record::media(){
    unsigned int i = 0;
    float somma = 0;
    for(i = 0; i < v.size(); i++){
        somma += v[i];
    }
    return somma/v.size();
}

